<#--
/* Copyright 2009-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 -->
 <#macro getCoverageClass node>
    <#local covnum = coverage.getCoverageClass(node)/>
    <#local covclass = "red"/>
    <#if covnum = 1>
    	<#local covclass = "yellow"/>
    <#else>
    	<#if covnum = 2>
    		<#local covclass = "green"/>	
    	</#if>
    </#if>
    <#assign cclass = covclass/>
 </#macro>
 <#macro showreq req lvl showbuttons>
    <#local node = req/>
    <#local childrenList = node.getSortedChildren()/>
    <@getCoverageClass node/>
    <#local covclass = cclass/>
    <#list childrenList as child>
        <#if child.getType() = "Requirement">
            <#local hasChild = 1/>
        <#else>
        	<#if child.getType() = "TestPurpose">
            	<#local hasChild = 1/>
        	</#if>    
        </#if>    
    </#list>
    <#local testsCount = coverage.getCoverageTestCount(node.getQualifiedId())/>
    <#if (testsCount>0)>
    	<#local testPathList = coverage.getCoveragePaths(node.getQualifiedId())/>
    	<#local testCntList = coverage.getCoverageCounts(node.getQualifiedId())/>
    </#if>
    <tr><td>&nbsp;</td></tr>
    <tr class="${covclass}">
    	<td align = "right">
    		<table border = "0" width = "100%" cellpadding="0" cellspacing = "0">
    			<tr>
    				<th><h${lvl}><strong>${utils.htmlEscape(node.getUserFriendlyName(true))}</strong></h${lvl}></th>
    				<#if showbuttons><td width = "50" class="addtest" onclick='callAddTest("${node.getQualifiedId()}");return false'>Add test</td></#if>
    			</tr>
    		</table>
    	</td>
    </tr>
    
        <#if coverage.hasErrors(node.getQualifiedId())>
        	<tr><td bgcolor = "#ffaaff">
            <#local errors_desc=coverage.getErrorDescriptionsForNode(node.getQualifiedId())/>
        	<#local errors_names=coverage.getErrorNamesForNode(node.getQualifiedId())/>
        	<#list errors_names as error>
        		'${error}'
        	</#list>
        	<#list errors_desc as error>
        		'${error}'
        	</#list>
        	</td></tr>
        </#if>
    <#if (testsCount>0)>
    	<tr>
    		<td align = "right" style = "padding-left:20px;">
    			<table border = "1" width = "100%">
    				<tr><th>Test:</th><th>Hits:</th></tr>
    				<#local iterate = 0/>
    				<#list testPathList as path>
    					<tr><td width = "75%" onclick = 'if(openEditor("${path}")!=null)return false;window.location.href="${path}";'><a href = "#">${path}</a></td><td width = "25%">${testCntList[iterate]}</td></tr>
    					<#local iterate = iterate + 1/>
            		</#list>
	           	</table>
	        </td>
    	</tr>
    </#if>
    <#if (hasChild!0) != 0>
        <tr><td style = "padding-left:20px;">
        <div style="margin-left:${(lvl-1)*10}px;">
        <#if node.getDescription(reportLocation)?has_content>
            ${utils.htmlSpaces(node.getDescription(reportLocation))}
        <#else>
        	<#if node.getType() == "Requirement">
            	<#list node.getLocations() as location>
                	<#if (li!0) != 0>
                    	<br/>...
                	</#if>
                	<#if !location.isHidden()>
	                    ${utils.htmlSpaces(location.getDescription(reportLocation))}
    	            </#if>
        	        <#local li = 1/>
            	</#list>
            </#if>
        </#if>
        </div>
        <#local childrenTestPurposeList = node.getSortedChildren("TestPurpose")/>
        	<#list childrenTestPurposeList as childTestPurpose>
        		<@getCoverageClass childTestPurpose/>
                <#if (tc!0) = 0 >
                   <table class="testpurpose ${cclass}" border="1">
                       <tr><th>Номер</th><th>Описание</th><th>Ожидаемые результаты</th><td><table cellpadding="0" cellspacing="0" width = "100%"><tr><th>Teсты</th><#if showbuttons><td width = "50" class="addtest" onclick='callAddTest("${childTestPurpose.getQualifiedId()}");return false'>Add test</td></#if></tr></table></td><th>Статус</th></tr>
                </#if>
                <tr><td>${utils.htmlEscape(childTestPurpose.getId())} </td><td>${utils.htmlSpaces(childTestPurpose.getDescription(reportLocation))!""} </td><td>${utils.htmlSpaces(childTestPurpose.getExpectedResults(reportLocation))} </td><td><#local testsCount = coverage.getCoverageTestCount(childTestPurpose.getQualifiedId())/><#local testPathList = coverage.getCoveragePaths(childTestPurpose.getQualifiedId())/><#local testCntList = coverage.getCoverageCounts(childTestPurpose.getQualifiedId())/><#if (testsCount>0)><table border = "0" width = "100%"><tr><th>Test:</th><th>Hits:</th></tr><#local iterate = 0/><#list testPathList as path><tr><td width = "75%" onclick = 'if(openEditor("${path}")!=null)return false;window.location.href="${path}";'><a href = "#">${path}</a></td><td width = "25%">${testCntList[iterate]}</td></tr><#local iterate = iterate + 1/></#list></table></#if></td><td>${childTestPurpose.getAttributeValue("_status", "")}</td></tr>
        	</#list>
        	<table width = "100%" cellpadding="0" cellspacing = "0" style = "border-left: solid 1px transparent;border-color: rgb(236, 240, 241)" ;>
        		<#list childrenList as child>
            		<#if child.getType() = "Requirement">
                		<@showreq child lvl+1 showbuttons/>
            		</#if> 
        		</#list>
        	</table>
        </td>
        </tr>
    <#else>
    	<tr><td>
        <div style="margin-left:${(lvl-1)*10}px;">
        <#if node.getDescription(reportLocation)?has_content>
            ${utils.htmlSpaces(node.getDescription(reportLocation))}
        <#else>
        	<#if node.getType()=="Requirement">
            	<#list node.getLocations() as location>
                	<#if (li!0) != 0 >
                    	<br/>...
                	</#if>
                	<#if !location.isHidden()>
                    	${utils.htmlSpaces(location.getDescription(reportLocation))}
                	</#if>
                	<#local li = 1/>
            	</#list>
            </#if>
        </#if>
        </div>
        </td></tr>
    </#if>    
</#macro>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
.reqid {
    vertical-align: top;
    padding: 5px;
    margin-bottom: 1px;
}
.reqtxt {
    padding-left: 5px;
    padding-right: 5px;
}
.testpurpose {
    width: 100%;
}
.green {
    background-color: #DDFFDD;
}
.red {
    background-color: #FFDDDD;
}
.yellow {
    background-color: #FFFFCC;
}
.blue {
    background-color: #CCCCFF;
}
.addtest{
	background: linear-gradient(to top, #FFFFFF, rgb(236, 240, 241));
	background-color: rgb(236, 240, 241);
	border: 2px outset rgb(189, 195, 199);
	text-align:center;
	font-weight:bold;
	color:black;
	cursor: pointer; cursor: hand;
}
</style>
</head>
<body>
<#if coverageFilePath?? || coverageStorageType??>
	<#if coverage.loadStorage()>
		<table border="0" width = "100%">
		<#if noAddTestButtons?? && noAddTestButtons!="false">
			<#assign showButtons = false>
		<#else>
			<#assign showButtons = true>
		</#if>
		<@showreq rootReq 1 showButtons/>
		</table>
	<#else>
		<#if coverageFilePath??>
			Coverage information cannot be loaded from 	${coverageFilePath}. Errors: ${coverage.getLastErrors()}
		<#else>
			Coverage information cannot be loaded from chosen source. Errors: ${coverage.getLastErrors()}
		</#if>
	</#if>	
<#else>
	Attribute 'coverageFilePath' is not set and alternative sources of coverage are not described. Please set attribute to coverage info file 
	or use alternative sources of coverage data. 
</#if>
</body>
</html>
